/**
* Script: nettest.js
* Written by: Radnen
* Updated: 12/9/2011
**/

RequireScript("networking.js");

var g_text = "";

function game()
{
	while (!IsKeyPressed(KEY_ESCAPE)) {
		ShowMessage(0, "is host: " + Network.isHost);
		ShowMessage(1, "address: " + Network.address + " (" + Network.port + ")");
		if (Network.isHost)
			ShowMessage(2, "clients: " + Network.connections.length);
		ShowMessage(3, "message: " + g_text);
		FlipScreen();
		
		Update();
		
		while (AreKeysLeft()) {
			switch (GetKey()) {
				case KEY_H:
					HostGame();
				break;
				case KEY_J:
					JoinGame();
				break;
				case KEY_S:
					Say("Hello All!");
				break;
				case KEY_A:
					Say("Awesome!!!");
				break;
			}
		}
	}
}

function HostGame()
{
	if (!Network.host(1123)) {
		Abort("Networking error!");
	}
}

function JoinGame()
{
	if (!Network.join(GetLocalAddress(), 1123)) {
		Abort("Networking error, or Local Address doesn't exist!");
	}
	
	while (!Network.connect()) {
		ShowMessage("Connecting...");// to: " + Network.address + " (" + Network.port + ")");
		FlipScreen();
	}
}

// an example of sending data through the network:
function Say(string)
{
	Network.send(string);
	if (Network.isHost) ProcessData(string); // because the host can't send to itself.
}

// convenience function for drawing a message
function ShowMessage(position, msg)
{
	GetSystemFont().drawText(0, position*10, msg);
}

// updates the network's listening.
function Update()
{
	// update client related data:
	if (!Network.isHost) {
		var data = Network.receive();
		if (data != null) {
			// process the data for the client
			ProcessData(data);
		}
	}
	else { // update host related data:
		// makes host look for clients:
		Network.hostListen();
		
		// seeks data from clients:
		Network.seek();
		
		// grabs first data entry from clients:
		var data = Network.grab();
		if (data != null) {
			// process the data for the host
			ProcessData(data);
			
			// send the data to everyone else
			Network.send(data);
		}
	}
}

function ProcessData(data)
{
	g_text = data;
}